#include "stm32f10x.h"
#include "25QXX.h"

void delay_us(u32 times)
{
	times=times*10;
	while(times--);
}
//////////////////////////////////////////////////////////////////////////////////	 
//ֻѧϰʹãδɣκ;
//Mini STM32
//SPI 	   
//ԭ@ALIENTEK
//̳:www.openedv.com
//޸:2010/6/13 
//汾V1.0
//ȨУؾ
//Copyright(C) ԭ 2009-2019
//All rights reserved
////////////////////////////////////////////////////////////////////////////////// 	  
 

//SPIģĳʼ룬óģʽSD Card/W25X16/24L01/JF24C							  
//SPIڳʼ
//ǶSPI1ĳʼ

SPI_InitTypeDef  SPI_InitStructure;

void SPI2_Init(void)
{
	GPIO_InitTypeDef GPIO_InitStructure;
  
	RCC_APB2PeriphClockCmd(	RCC_APB2Periph_GPIOB, ENABLE );	
	RCC_APB1PeriphClockCmd(	RCC_APB1Periph_SPI2, ENABLE );
	
 	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_12;//NSS PB12
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP; 
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
	GPIO_Init(GPIOB, &GPIO_InitStructure);
	
	GPIO_SetBits(GPIOB,GPIO_Pin_12);
	
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_13 | GPIO_Pin_14 | GPIO_Pin_15;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;  
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
	GPIO_Init(GPIOB, &GPIO_InitStructure);

 	GPIO_SetBits(GPIOB,GPIO_Pin_5|GPIO_Pin_6|GPIO_Pin_7);
	

	SPI_InitStructure.SPI_Direction = SPI_Direction_2Lines_FullDuplex;  //SPI˫ģʽ:SPIΪ˫˫ȫ˫
	SPI_InitStructure.SPI_Mode = SPI_Mode_Master;		//SPIģʽ:ΪSPI
	SPI_InitStructure.SPI_DataSize = SPI_DataSize_8b;		//SPIݴС:SPIͽ8λ֡ṹ
	SPI_InitStructure.SPI_CPOL = SPI_CPOL_High;		//ѡ˴ʱӵ̬:ʱո
	SPI_InitStructure.SPI_CPHA = SPI_CPHA_2Edge;	//ݲڵڶʱ
	SPI_InitStructure.SPI_NSS = SPI_NSS_Soft;		//NSSźӲNSSܽţʹSSIλ:ڲNSSźSSIλ
	SPI_InitStructure.SPI_BaudRatePrescaler = SPI_BaudRatePrescaler_256;		//岨ԤƵֵ:ԤƵֵΪ256
	SPI_InitStructure.SPI_FirstBit = SPI_FirstBit_MSB;	//ָݴMSBλLSBλʼ:ݴMSBλʼ
	SPI_InitStructure.SPI_CRCPolynomial = 7;	//CRCֵĶʽ
	SPI_Init(SPI2, &SPI_InitStructure);  //SPI_InitStructָĲʼSPIxĴ
 
	SPI_Cmd(SPI2, ENABLE); //ʹSPI
	
	SPI2_ReadWriteByte(0xff);//		 
}   
//SPI ٶú
//SpeedSet:
//SPI_BaudRatePrescaler_2   2Ƶ   (SPI 36M@sys 72M)
//SPI_BaudRatePrescaler_8   8Ƶ   (SPI 9M@sys 72M)
//SPI_BaudRatePrescaler_16  16Ƶ  (SPI 4.5M@sys 72M)
//SPI_BaudRatePrescaler_256 256Ƶ (SPI 281.25K@sys 72M)
  
void SPI2_SetSpeed(u8 SpeedSet)
{
		SPI_InitStructure.SPI_BaudRatePrescaler = SpeedSet ;
		SPI_Init(SPI2, &SPI_InitStructure);
		SPI_Cmd(SPI2,ENABLE);
} 

//SPIx дһֽ
//TxData:Ҫдֽ
//ֵ:ȡֽ
u8 SPI2_ReadWriteByte(u8 TxData)
{		
		u8 retry=0;				 	
		while (SPI_I2S_GetFlagStatus(SPI2, SPI_I2S_FLAG_TXE) == RESET) //ָSPI־λ:ͻձ־λ
		{
		retry++;
		if(retry>200)return 0;
		}			  
		SPI_I2S_SendData(SPI2, TxData); //ͨSPIxһ
		retry=0;

		while (SPI_I2S_GetFlagStatus(SPI2, SPI_I2S_FLAG_RXNE) == RESET)//ָSPI־λ:ܻǿձ־λ
		{
		retry++;
		if(retry>200)return 0;
		}	  						    
		return SPI_I2S_ReceiveData(SPI2); //ͨSPIxյ					    
}



//Mini STM32
//W25X16  
//ԭ@ALIENTEK
//2010/6/13
//V1.0
u16 SPI_FLASH_TYPE=W25Q64;//ĬϾ25Q64
//4KbytesΪһSector
//16Ϊ1Block
//W25X16
//Ϊ2Mֽ,32Block,512Sector 

//ʼSPI FLASHIO
void SPI_Flash_Init(void)
{

	SPI2_Init();		   //ʼSPI
	SPI2_SetSpeed(SPI_BaudRatePrescaler_4);	//Ϊ18Mʱ,ģʽ
	SPI_FLASH_TYPE=SPI_Flash_ReadID();//ȡFLASH ID.
}  

//ȡSPI_FLASH״̬Ĵ
//BIT7  6   5   4   3   2   1   0
//SPR   RV  TB BP2 BP1 BP0 WEL BUSY
//SPR:Ĭ0,״̬Ĵλ,WPʹ
//TB,BP2,BP1,BP0:FLASHд
//WEL:дʹ
//BUSY:æλ(1,æ;0,)
//Ĭ:0x00
u8 SPI_Flash_ReadSR(void)   
{  
	u8 byte=0;   
	FLASH_CS_L();                            //ʹ   
	SPI2_ReadWriteByte(W25X_ReadStatusReg);    //Ͷȡ״̬Ĵ    
	byte=SPI2_ReadWriteByte(0Xff);             //ȡһֽ  
	FLASH_CS_H()	;                            //ȡƬѡ     
	return byte;   
} 
//дSPI_FLASH״̬Ĵ
//ֻSPR,TB,BP2,BP1,BP0(bit 7,5,4,3,2)д!!!
void SPI_FLASH_Write_SR(u8 sr)   
{   
		FLASH_CS_L();                            //ʹ   
		SPI2_ReadWriteByte(W25X_WriteStatusReg);   //дȡ״̬Ĵ    
		SPI2_ReadWriteByte(sr);               //дһֽ  
		FLASH_CS_H();                            //ȡƬѡ     	      
}   
//SPI_FLASHдʹ	
//WELλ   
void SPI_FLASH_Write_Enable(void)   
{
		FLASH_CS_L();                            //ʹ   
		SPI2_ReadWriteByte(W25X_WriteEnable);      //дʹ  
		FLASH_CS_H()	;                            //ȡƬѡ     	      
} 
//SPI_FLASHдֹ	
//WEL  
void SPI_FLASH_Write_Disable(void)   
{  
		FLASH_CS_L();                            //ʹ   
		SPI2_ReadWriteByte(W25X_WriteDisable);     //дָֹ    
		FLASH_CS_H();                            //ȡƬѡ     	      
} 			    
//ȡоƬID W25X16ID:0XEF14
u16 SPI_Flash_ReadID(void)
{
		u16 Temp = 0;	  
		FLASH_CS_L();				    
		SPI2_ReadWriteByte(0x90);//ͶȡID	    
		SPI2_ReadWriteByte(0x00); 	    
		SPI2_ReadWriteByte(0x00); 	    
		SPI2_ReadWriteByte(0x00); 	 			   
		Temp|=SPI2_ReadWriteByte(0xFF)<<8;  
		Temp|=SPI2_ReadWriteByte(0xFF);	 
		FLASH_CS_H();				    
		return Temp;
}   		    
//ȡSPI FLASH  
//ַָʼȡָȵ
//pBuffer:ݴ洢
//ReadAddr:ʼȡĵַ(24bit)
//NumByteToRead:Ҫȡֽ(65535)
void SPI_Flash_Read(u8* pBuffer,u32 ReadAddr,u16 NumByteToRead)   
{ 
		u16 i;    												    
		FLASH_CS_L();                            //ʹ   
    SPI2_ReadWriteByte(W25X_ReadData);         //Ͷȡ   
    SPI2_ReadWriteByte((u8)((ReadAddr)>>16));  //24bitַ    
    SPI2_ReadWriteByte((u8)((ReadAddr)>>8));   
    SPI2_ReadWriteByte((u8)ReadAddr);   
    for(i=0;i<NumByteToRead;i++)
		{ 
       pBuffer[i]=SPI2_ReadWriteByte(0XFF);   //ѭ  
    }
		FLASH_CS_H();                            //ȡƬѡ     	      
}  
//SPIһҳ(0~65535)д256ֽڵ
//ַָʼд256ֽڵ
//pBuffer:ݴ洢
//WriteAddr:ʼдĵַ(24bit)
//NumByteToWrite:Ҫдֽ(256),Ӧóҳʣֽ!!!	 
void SPI_Flash_Write_Page(u8* pBuffer,u32 WriteAddr,u16 NumByteToWrite)
{
		u16 i;  
    SPI_FLASH_Write_Enable();                  //SET WEL 
		FLASH_CS_L();                            //ʹ   
    SPI2_ReadWriteByte(W25X_PageProgram);      //дҳ   
    SPI2_ReadWriteByte((u8)((WriteAddr)>>16)); //24bitַ    
    SPI2_ReadWriteByte((u8)((WriteAddr)>>8));   
    SPI2_ReadWriteByte((u8)WriteAddr);   
    for(i=0;i<NumByteToWrite;i++)SPI2_ReadWriteByte(pBuffer[i]);//ѭд  
		FLASH_CS_H();                            //ȡƬѡ 
		SPI_Flash_Wait_Busy();					   //ȴд
} 
//޼дSPI FLASH 
//ȷдĵַΧڵȫΪ0XFF,ڷ0XFFдݽʧ!
//Զҳ 
//ַָʼдָȵ,ҪȷַԽ!
//pBuffer:ݴ洢
//WriteAddr:ʼдĵַ(24bit)
//NumByteToWrite:Ҫдֽ(65535)
//CHECK OK
void SPI_Flash_Write_NoCheck(u8* pBuffer,u32 WriteAddr,u16 NumByteToWrite)   
{ 			 		 
	u16 pageremain;	   
	pageremain=256-WriteAddr%256; //ҳʣֽ		 	    
	if(NumByteToWrite<=pageremain)pageremain=NumByteToWrite;//256ֽ
	while(1)
	{	   
		SPI_Flash_Write_Page(pBuffer,WriteAddr,pageremain);
		if(NumByteToWrite==pageremain)
			break;//д
	 	else //NumByteToWrite>pageremain
		{
			pBuffer+=pageremain;
			WriteAddr+=pageremain;	

			NumByteToWrite-=pageremain;			  //ȥѾд˵ֽ
			if(NumByteToWrite>256)pageremain=256; //һοд256ֽ
			else pageremain=NumByteToWrite; 	  //256ֽ
		}
	};	    
} 
//дSPI FLASH  
//ַָʼдָȵ
//ú!
//pBuffer:ݴ洢
//WriteAddr:ʼдĵַ(24bit)
//NumByteToWrite:Ҫдֽ(65535)  		   
u8 SPI_FLASH_BUF[4096];
void SPI_Flash_Write(u8* pBuffer,u32 WriteAddr,u16 NumByteToWrite)   
{ 
	u32 secpos;
	u16 secoff;
	u16 secremain;	   
 	u16 i;    

	secpos=WriteAddr/4096;//ַ 0~511 for w25x16
	secoff=WriteAddr%4096;//ڵƫ
	secremain=4096-secoff;//ʣռС   

	if(NumByteToWrite<=secremain)secremain=NumByteToWrite;//4096ֽ
	while(1) 
	{	
		SPI_Flash_Read(SPI_FLASH_BUF,secpos*4096,4096);//
		for(i=0;i<secremain;i++)//У
		{
			if(SPI_FLASH_BUF[secoff+i]!=0XFF)break;//Ҫ  	  
		}
		if(i<secremain)//Ҫ
		{
			SPI_Flash_Erase_Sector(secpos);//
			for(i=0;i<secremain;i++)	   //
			{
				SPI_FLASH_BUF[i+secoff]=pBuffer[i];	  
			}
			SPI_Flash_Write_NoCheck(SPI_FLASH_BUF,secpos*4096,4096);//д  

		}else SPI_Flash_Write_NoCheck(pBuffer,WriteAddr,secremain);//дѾ˵,ֱдʣ. 				   
		if(NumByteToWrite==secremain)break;//д
		else//дδ
		{
			secpos++;//ַ1
			secoff=0;//ƫλΪ0 	 

		   	pBuffer+=secremain;  //ָƫ
			WriteAddr+=secremain;//дַƫ	   
		   	NumByteToWrite-=secremain;				//ֽݼ
			if(NumByteToWrite>4096)secremain=4096;	//һд
			else secremain=NumByteToWrite;			//һд
		}	 
	};	 	 
}
//оƬ
//Ƭʱ:
//W25X16:25s 
//W25X32:40s 
//W25X64:40s 
//ȴʱ䳬...
void SPI_Flash_Erase_Chip(void)   
{                                             
		SPI_FLASH_Write_Enable();                  //SET WEL 
		SPI_Flash_Wait_Busy();   
		FLASH_CS_L();                            //ʹ   
		SPI2_ReadWriteByte(W25X_ChipErase);        //Ƭ  
		FLASH_CS_H();                            //ȡƬѡ     	      
		SPI_Flash_Wait_Busy();   				   //ȴоƬ
}   
//һ
//Dst_Addr:ַ 0~511 for w25x16
//һɽʱ:150ms
void SPI_Flash_Erase_Sector(u32 Dst_Addr)   
{   
		Dst_Addr*=4096;
		SPI_FLASH_Write_Enable();                  //SET WEL 	 
		SPI_Flash_Wait_Busy();   
		FLASH_CS_L();                            //ʹ   
		SPI2_ReadWriteByte(W25X_SectorErase);      //ָ 
		SPI2_ReadWriteByte((u8)((Dst_Addr)>>16));  //24bitַ    
		SPI2_ReadWriteByte((u8)((Dst_Addr)>>8));   
		SPI2_ReadWriteByte((u8)Dst_Addr);  
		FLASH_CS_H()	;                            //ȡƬѡ     	      
		SPI_Flash_Wait_Busy();   				   //ȴ
}  
//ȴ
void SPI_Flash_Wait_Busy(void)   
{   
	while ((SPI_Flash_ReadSR()&0x01)==0x01);   // ȴBUSYλ
}  
//ģʽ
void SPI_Flash_PowerDown(void)   
{ 
		FLASH_CS_L();                            //ʹ   
		SPI2_ReadWriteByte(W25X_PowerDown);        //͵  
		FLASH_CS_H();                            //ȡƬѡ     	      
		delay_us(3);                               //ȴTPD  
}   
//
void SPI_Flash_WAKEUP(void)   
{  
		FLASH_CS_L();                            //ʹ   
		SPI2_ReadWriteByte(W25X_ReleasePowerDown);   //  send W25X_PowerDown command 0xAB    
		FLASH_CS_H();                            //ȡƬѡ     	      
		delay_us(3);                               //ȴTRES1
}   





















































