#ifndef __25QXX_H
#define __25QXX_H

#include "stm32f10x.h"



#define  FLASH_CS_L()	 GPIO_ResetBits(GPIOB, GPIO_Pin_12) 			 
#define  FLASH_CS_H()	 GPIO_SetBits(GPIOB, GPIO_Pin_12) 

#define W25Q80 	0XEF13 	
#define W25Q16 	0XEF14
#define W25Q32 	0XEF15
#define W25Q64 	0XEF16
//#define	SPI_FLASH_CS PAout(2)  //ѡFLASH			
//W25X16д
#define FLASH_ID 0XEF14
//ָ
#define W25X_WriteEnable		0x06 
#define W25X_WriteDisable		0x04 
#define W25X_ReadStatusReg		0x05 
#define W25X_WriteStatusReg		0x01 
#define W25X_ReadData			0x03 
#define W25X_FastReadData		0x0B 
#define W25X_FastReadDual		0x3B 
#define W25X_PageProgram		0x02 
#define W25X_BlockErase			0xD8 
#define W25X_SectorErase		0x20 
#define W25X_ChipErase			0xC7 
#define W25X_PowerDown			0xB9 
#define W25X_ReleasePowerDown	0xAB 
#define W25X_DeviceID			0xAB 
#define W25X_ManufactDeviceID	0x90 
#define W25X_JedecDeviceID		0x9F 

extern u16 SPI_FLASH_TYPE;		//ʹõflashоƬͺ		
extern u8 SPI_FLASH_BUF[4096];

void SPI2_Init(void);			 //ʼSPI
void SPI2_SetSpeed(u8 SpeedSet); //SPIٶ   
u8 SPI2_ReadWriteByte(u8 TxData);//SPI߶дһֽ


void SPI_Flash_Init(void);
u16  SPI_Flash_ReadID(void);  	    //ȡFLASH ID
u8	 SPI_Flash_ReadSR(void);        //ȡ״̬Ĵ 
void SPI_FLASH_Write_SR(u8 sr);  	//д״̬Ĵ
void SPI_FLASH_Write_Enable(void);  //дʹ 
void SPI_FLASH_Write_Disable(void);	//д
void SPI_Flash_Read(u8* pBuffer,u32 ReadAddr,u16 NumByteToRead);   //ȡflash
void SPI_Flash_Write(u8* pBuffer,u32 WriteAddr,u16 NumByteToWrite);//дflash
void SPI_Flash_Erase_Chip(void);    	  //Ƭ
void SPI_Flash_Erase_Sector(u32 Dst_Addr);//
void SPI_Flash_Wait_Busy(void);           //ȴ
void SPI_Flash_PowerDown(void);           //ģʽ
void SPI_Flash_WAKEUP(void);			  //




#endif

