/*
		2014.10.11 ȷʽ v1.0
*/
#include "stm32f10x.h"
#include "USART_DMA_INIT.h"

u8 USART1_Send_Num;
u8 USART2_Send_Num;
u8 USART3_Send_Num;

u8 Rx1Buffer[30];
u8 Tx1Buffer[30];

u8 Rx2Buffer[20];
u8 Tx2Buffer[20];

u8 Rx3Buffer[20];
u8 Tx3Buffer[20];


u8 dma_usart1_se_flag;
u8 dma_usart1_re_flag;

u8 dma_usart2_se_flag;
u8 dma_usart2_re_flag;

u8 dma_usart3_se_flag;
u8 dma_usart3_re_flag;

u16 usart1_re_dma_timeout,usart1_re_dma_sum;	
u16 usart2_re_dma_timeout,usart2_re_dma_sum;	
u16 usart3_re_dma_timeout,usart3_re_dma_sum;	

//--------------------------------------------------------

void usart1_nvic_init(void)
{	
	NVIC_InitTypeDef NVIC_InitStructure;
	/* Configure one bit for preemption priority */
	NVIC_PriorityGroupConfig(NVIC_PriorityGroup_1);
	
	NVIC_InitStructure.NVIC_IRQChannel =DMA1_Channel4_IRQn; 
	NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 2; //ռȼ
	NVIC_InitStructure.NVIC_IRQChannelSubPriority = 5; 		//ȼ
	NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
	NVIC_Init(&NVIC_InitStructure); 
	
	NVIC_InitStructure.NVIC_IRQChannel =DMA1_Channel5_IRQn; 
	NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 2; //ռȼ
	NVIC_InitStructure.NVIC_IRQChannelSubPriority = 5; 		//ȼ
	NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
	NVIC_Init(&NVIC_InitStructure); 

}

void usart2_nvic_init(void)
{	
	NVIC_InitTypeDef NVIC_InitStructure;
	/* Configure one bit for preemption priority */
	NVIC_PriorityGroupConfig(NVIC_PriorityGroup_1);
	
	NVIC_InitStructure.NVIC_IRQChannel =DMA1_Channel6_IRQn; 
	NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 3; //ռȼ
	NVIC_InitStructure.NVIC_IRQChannelSubPriority = 4; 		//ȼ
	NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
	NVIC_Init(&NVIC_InitStructure); 
	
	NVIC_InitStructure.NVIC_IRQChannel =DMA1_Channel7_IRQn; 
	NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 3; //ռȼ
	NVIC_InitStructure.NVIC_IRQChannelSubPriority = 4; 		//ȼ
	NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
	NVIC_Init(&NVIC_InitStructure); 	 
	
}

void usart3_nvic_init(void)
{	
	NVIC_InitTypeDef NVIC_InitStructure;
	/* Configure one bit for preemption priority */
	NVIC_PriorityGroupConfig(NVIC_PriorityGroup_1);
	
	NVIC_InitStructure.NVIC_IRQChannel =DMA1_Channel2_IRQn; 
	NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 3; //ռȼ
	NVIC_InitStructure.NVIC_IRQChannelSubPriority = 4; 		//ȼ
	NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
	NVIC_Init(&NVIC_InitStructure); 
	
	NVIC_InitStructure.NVIC_IRQChannel =DMA1_Channel3_IRQn; 
	NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 3; //ռȼ
	NVIC_InitStructure.NVIC_IRQChannelSubPriority = 4; 		//ȼ
	NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
	NVIC_Init(&NVIC_InitStructure); 	
}

void usart1_gpio_init(void)
{
	GPIO_InitTypeDef GPIO_InitStructure;

	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_9;			 //PA9 TXD1
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;       
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
	GPIO_Init(GPIOA, &GPIO_InitStructure);

	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_10;			 //PA10 RXD1
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN_FLOATING;      
	GPIO_Init(GPIOA, &GPIO_InitStructure);
}

void usart2_gpio_init(void)
{
	GPIO_InitTypeDef GPIO_InitStructure;
	
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_2;			 //PA2 TXD2
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;       
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
	GPIO_Init(GPIOA, &GPIO_InitStructure);

	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_3;			 //PA3 RXD2
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN_FLOATING;      
	GPIO_Init(GPIOA, &GPIO_InitStructure);
}

void usart3_gpio_init(void)
{
	GPIO_InitTypeDef GPIO_InitStructure;
	
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_10;			 //PB10 TXD3
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;       
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
	GPIO_Init(GPIOB, &GPIO_InitStructure);

	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_11;			 //PB11 RXD3
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN_FLOATING;      
	GPIO_Init(GPIOB, &GPIO_InitStructure);
}

void usart1_init(void)
{	 
	USART_InitTypeDef USART_InitStructure;
	
	RCC_APB2PeriphClockCmd(RCC_APB2Periph_USART1,ENABLE); //1ʱ
	RCC_AHBPeriphClockCmd(RCC_AHBPeriph_DMA1,ENABLE); //DMAʱ

	/*congig usart1*/
	USART_InitStructure.USART_BaudRate = USART1_Speed;
	USART_InitStructure.USART_WordLength = USART_WordLength_8b;
	USART_InitStructure.USART_StopBits = USART_StopBits_1;
	USART_InitStructure.USART_Parity = USART_Parity_No ;
	USART_InitStructure.USART_HardwareFlowControl = USART_HardwareFlowControl_None;
	USART_InitStructure.USART_Mode = USART_Mode_Rx | USART_Mode_Tx;
	USART_Init(USART1, &USART_InitStructure);
	
	USART_Cmd(USART1, ENABLE);
	
	//	USART_ITConfig(USART1, USART_IT_RXNE  ,ENABLE);    //ж
	USART_DMACmd(USART1,USART_DMAReq_Tx, ENABLE); 	 //ʹDMA
	USART_DMACmd(USART1,USART_DMAReq_Rx, ENABLE); 	 //DMA 
	USART_ClearFlag(USART1,USART_FLAG_TC); //һֽڷȥ  Ҫ־	  0x40013804
}

void usart2_init(void)
{	 
	USART_InitTypeDef USART_InitStructure;
	
	RCC_APB1PeriphClockCmd(RCC_APB1Periph_USART2,ENABLE); //2ʱ
	RCC_AHBPeriphClockCmd(RCC_AHBPeriph_DMA1,ENABLE); //DMAʱ

	/*congig usart1*/
	USART_InitStructure.USART_BaudRate = USART2_Speed;
	USART_InitStructure.USART_WordLength = USART_WordLength_8b;
	USART_InitStructure.USART_StopBits = USART_StopBits_1;
	USART_InitStructure.USART_Parity = USART_Parity_No ;
	USART_InitStructure.USART_HardwareFlowControl = USART_HardwareFlowControl_None;
	USART_InitStructure.USART_Mode = USART_Mode_Rx | USART_Mode_Tx;
	USART_Init(USART2, &USART_InitStructure);
	
	USART_Cmd(USART2, ENABLE);
	
//	USART_ITConfig(USART2, USART_IT_RXNE  ,ENABLE);    //ж
	USART_DMACmd(USART2,USART_DMAReq_Tx, ENABLE); 	 //ʹDMA
	USART_DMACmd(USART2,USART_DMAReq_Rx, ENABLE); 	 //DMA 
	USART_ClearFlag(USART2,USART_FLAG_TC); //һֽڷȥ  Ҫ־	  0x40013804
}

void usart3_init(void)
{	 
	USART_InitTypeDef USART_InitStructure;
	
	RCC_APB1PeriphClockCmd(RCC_APB1Periph_USART3,ENABLE); //2ʱ
	RCC_AHBPeriphClockCmd(RCC_AHBPeriph_DMA1,ENABLE); //DMAʱ

	/*congig usart1*/
	USART_InitStructure.USART_BaudRate = USART3_Speed;
	USART_InitStructure.USART_WordLength = USART_WordLength_8b;
	USART_InitStructure.USART_StopBits = USART_StopBits_1;
	USART_InitStructure.USART_Parity = USART_Parity_No ;
	USART_InitStructure.USART_HardwareFlowControl = USART_HardwareFlowControl_None;
	USART_InitStructure.USART_Mode = USART_Mode_Rx | USART_Mode_Tx;
	USART_Init(USART3, &USART_InitStructure);
	
	USART_Cmd(USART3, ENABLE);
	
//	USART_ITConfig(USART3, USART_IT_RXNE  ,ENABLE);    //ж
	USART_DMACmd(USART3,USART_DMAReq_Tx, ENABLE); 	 //ʹDMA
	USART_DMACmd(USART3,USART_DMAReq_Rx, ENABLE); 	 //DMA 
	USART_ClearFlag(USART3,USART_FLAG_TC); //һֽڷȥ  Ҫ־	  0x40013804
}

void usart1_se_dma_init(u8 *TxBuffer,u8 Number)//dma usart1 send	   DMA1_Channel4
{	
	DMA_InitTypeDef   DMA_InitStructure; 
	DMA_DeInit(DMA1_Channel4); //DMA

  DMA_InitStructure.DMA_PeripheralBaseAddr = 0x40013804;	   //ַ USART_DR Ĵĵַ
	DMA_InitStructure.DMA_MemoryBaseAddr = (uint32_t)TxBuffer;//͵ַ
	DMA_InitStructure.DMA_DIR = DMA_DIR_PeripheralDST;		    //ΪݴĿĵ 
	DMA_InitStructure.DMA_BufferSize=Number; 
	DMA_InitStructure.DMA_PeripheralInc = DMA_PeripheralInc_Disable; //ַĴ 
	DMA_InitStructure.DMA_MemoryInc = DMA_MemoryInc_Enable;  //ڴַĴ 
	DMA_InitStructure.DMA_PeripheralDataSize = DMA_PeripheralDataSize_Byte; //ݿΪ 8 λ 
	DMA_InitStructure.DMA_MemoryDataSize = DMA_MemoryDataSize_Byte;//ݿΪ 8 λ 
	DMA_InitStructure.DMA_Mode = DMA_Mode_Normal; //ģʽ 
	DMA_InitStructure.DMA_Priority = DMA_Priority_VeryHigh;//DMA ͨ x ӵзǳȼ 
	DMA_InitStructure.DMA_M2M = DMA_M2M_Disable;//DMA ͨ x ûΪڴ浽ڴ洫 

	DMA_Init(DMA1_Channel4, &DMA_InitStructure); 
//	DMA_ITConfig(DMA1_Channel4,DMA_IT_TC|DMA_IT_HT|DMA_IT_TE,DISABLE );  //رж
	DMA_ITConfig(DMA1_Channel4,DMA_IT_TC,ENABLE);	//ж
//	DMA_Cmd(DMA1_Channel4,ENABLE);
}

void usart1_re_dma_init(u8 *RxBuffer,u8 Number)//dma usart1 reseve	   DMA1_Channel5
{	
	DMA_InitTypeDef   DMA_InitStructure; 
	DMA_DeInit(DMA1_Channel5); 

 	DMA_InitStructure.DMA_PeripheralBaseAddr = 0x40013804;	   //ַ USART_DR Ĵĵַ
	DMA_InitStructure.DMA_MemoryBaseAddr = (uint32_t)RxBuffer;//͵ַ
	DMA_InitStructure.DMA_DIR =DMA_DIR_PeripheralSRC; //ΪݴԴ
	DMA_InitStructure.DMA_BufferSize=Number; 
	DMA_InitStructure.DMA_PeripheralInc = DMA_PeripheralInc_Disable; //ַĴ 
	DMA_InitStructure.DMA_MemoryInc = DMA_MemoryInc_Enable;  //ڴַĴ 
	DMA_InitStructure.DMA_PeripheralDataSize = DMA_PeripheralDataSize_Byte; //ݿΪ 8 λ 
	DMA_InitStructure.DMA_MemoryDataSize = DMA_MemoryDataSize_Byte;//ݿΪ 8 λ 
	DMA_InitStructure.DMA_Mode = DMA_Mode_Normal; //ѭģʽ 
	DMA_InitStructure.DMA_Priority = DMA_Priority_High ;//DMA ͨ x ӵиȼ 
	DMA_InitStructure.DMA_M2M = DMA_M2M_Disable;//DMA ͨ x ûΪڴ浽ڴ洫 

	DMA_Init(DMA1_Channel5, &DMA_InitStructure); 
//	DMA_ITConfig(DMA1_Channel5,DMA_IT_TC|DMA_IT_HT|DMA_IT_TE,DISABLE );  //رж
	DMA_ITConfig(DMA1_Channel5,DMA_IT_TC,ENABLE);	//ж
	DMA_Cmd(DMA1_Channel5,ENABLE);
  DMA_ClearFlag(DMA1_FLAG_TC5);
}


void usart2_se_dma_init(u8 *TxBuffer,u8 Number)//dma usart1 send	   DMA1_Channel4
{	
	DMA_InitTypeDef   DMA_InitStructure; 
	DMA_DeInit(DMA1_Channel7); //DMA 0x4000 4400 - 0x4000 47FF 

  DMA_InitStructure.DMA_PeripheralBaseAddr = 0x40004404;	   //ַ USART_DR Ĵĵַ
	DMA_InitStructure.DMA_MemoryBaseAddr = (uint32_t)TxBuffer;//͵ַ
	DMA_InitStructure.DMA_DIR = DMA_DIR_PeripheralDST;		    //ΪݴĿĵ 
	DMA_InitStructure.DMA_BufferSize=Number; 
	DMA_InitStructure.DMA_PeripheralInc = DMA_PeripheralInc_Disable; //ַĴ 
	DMA_InitStructure.DMA_MemoryInc = DMA_MemoryInc_Enable;  //ڴַĴ 
	DMA_InitStructure.DMA_PeripheralDataSize = DMA_PeripheralDataSize_Byte; //ݿΪ 8 λ 
	DMA_InitStructure.DMA_MemoryDataSize = DMA_MemoryDataSize_Byte;//ݿΪ 8 λ 
	DMA_InitStructure.DMA_Mode = DMA_Mode_Normal; //ģʽ 
	DMA_InitStructure.DMA_Priority = DMA_Priority_Medium;//DMA ͨ x ӵзǳȼ 
	DMA_InitStructure.DMA_M2M = DMA_M2M_Disable;//DMA ͨ x ûΪڴ浽ڴ洫 

	DMA_Init(DMA1_Channel7, &DMA_InitStructure); 
//	DMA_ITConfig(DMA1_Channel4,DMA_IT_TC|DMA_IT_HT|DMA_IT_TE,DISABLE );  //رж
	DMA_ITConfig(DMA1_Channel7,DMA_IT_TC,ENABLE);	//ж
//	DMA_Cmd(DMA1_Channel4,ENABLE);
}

void usart2_re_dma_init(u8 *RxBuffer,u8 Number)//dma usart1 reseve	   DMA1_Channel5
{	
	DMA_InitTypeDef   DMA_InitStructure; 
	DMA_DeInit(DMA1_Channel6); 

 	DMA_InitStructure.DMA_PeripheralBaseAddr = 0x40004404;	   //ַ USART_DR Ĵĵַ
	DMA_InitStructure.DMA_MemoryBaseAddr = (uint32_t)RxBuffer;//͵ַ
	DMA_InitStructure.DMA_DIR =DMA_DIR_PeripheralSRC; //ΪݴԴ
	DMA_InitStructure.DMA_BufferSize=Number; 
	DMA_InitStructure.DMA_PeripheralInc = DMA_PeripheralInc_Disable; //ַĴ 
	DMA_InitStructure.DMA_MemoryInc = DMA_MemoryInc_Enable;  //ڴַĴ 
	DMA_InitStructure.DMA_PeripheralDataSize = DMA_PeripheralDataSize_Byte; //ݿΪ 8 λ 
	DMA_InitStructure.DMA_MemoryDataSize = DMA_MemoryDataSize_Byte;//ݿΪ 8 λ 
	DMA_InitStructure.DMA_Mode = DMA_Mode_Normal; //ѭģʽ  DMA_Mode_Circular
	DMA_InitStructure.DMA_Priority = DMA_Priority_VeryHigh ;//DMA ͨ x ӵиȼ 
	DMA_InitStructure.DMA_M2M = DMA_M2M_Disable;//DMA ͨ x ûΪڴ浽ڴ洫 

	DMA_Init(DMA1_Channel6, &DMA_InitStructure); 
//	DMA_ITConfig(DMA1_Channel5,DMA_IT_TC|DMA_IT_HT|DMA_IT_TE,DISABLE );  //رж
	DMA_ITConfig(DMA1_Channel6,DMA_IT_TC,ENABLE);	//ж
//	DMA_ITConfig(DMA1_Channel6,DMA_IT_HT,ENABLE);	//ж
	DMA_Cmd(DMA1_Channel6,ENABLE);
		 DMA_ClearFlag(DMA1_FLAG_TC6);
}

void usart3_se_dma_init(u8 *TxBuffer,u8 Number)//dma usart1 send	   DMA1_Channel4
{	
	DMA_InitTypeDef   DMA_InitStructure; 
	DMA_DeInit(DMA1_Channel2); //DMA 0x4000 4800 - 0x4000 4BFF          USART3 

  DMA_InitStructure.DMA_PeripheralBaseAddr = 0x40004804;	   //ַ USART_DR Ĵĵַ
	DMA_InitStructure.DMA_MemoryBaseAddr = (uint32_t)TxBuffer;//͵ַ
	DMA_InitStructure.DMA_DIR = DMA_DIR_PeripheralDST;		    //ΪݴĿĵ 
	DMA_InitStructure.DMA_BufferSize=Number; 
	DMA_InitStructure.DMA_PeripheralInc = DMA_PeripheralInc_Disable; //ַĴ 
	DMA_InitStructure.DMA_MemoryInc = DMA_MemoryInc_Enable;  //ڴַĴ 
	DMA_InitStructure.DMA_PeripheralDataSize = DMA_PeripheralDataSize_Byte; //ݿΪ 8 λ 
	DMA_InitStructure.DMA_MemoryDataSize = DMA_MemoryDataSize_Byte;//ݿΪ 8 λ 
	DMA_InitStructure.DMA_Mode = DMA_Mode_Normal; //ģʽ 
	DMA_InitStructure.DMA_Priority = DMA_Priority_Medium;//DMA ͨ x ӵзǳȼ 
	DMA_InitStructure.DMA_M2M = DMA_M2M_Disable;//DMA ͨ x ûΪڴ浽ڴ洫 

	DMA_Init(DMA1_Channel2, &DMA_InitStructure); 
//	DMA_ITConfig(DMA1_Channel2,DMA_IT_TC|DMA_IT_HT|DMA_IT_TE,DISABLE );  //رж
	DMA_ITConfig(DMA1_Channel2,DMA_IT_TC,ENABLE);	//ж
//	DMA_Cmd(DMA1_Channel2,ENABLE);
}

void usart3_re_dma_init(u8 *RxBuffer,u8 Number)//dma usart1 reseve	   DMA1_Channel5
{	
	DMA_InitTypeDef   DMA_InitStructure; 
	DMA_DeInit(DMA1_Channel3); 

 	DMA_InitStructure.DMA_PeripheralBaseAddr = 0x40004804;	   //ַ USART_DR Ĵĵַ
	DMA_InitStructure.DMA_MemoryBaseAddr = (uint32_t)RxBuffer;//͵ַ
	DMA_InitStructure.DMA_DIR =DMA_DIR_PeripheralSRC; //ΪݴԴ
	DMA_InitStructure.DMA_BufferSize=Number; 
	DMA_InitStructure.DMA_PeripheralInc = DMA_PeripheralInc_Disable; //ַĴ 
	DMA_InitStructure.DMA_MemoryInc = DMA_MemoryInc_Enable;  //ڴַĴ 
	DMA_InitStructure.DMA_PeripheralDataSize = DMA_PeripheralDataSize_Byte; //ݿΪ 8 λ 
	DMA_InitStructure.DMA_MemoryDataSize = DMA_MemoryDataSize_Byte;//ݿΪ 8 λ 
	DMA_InitStructure.DMA_Mode = DMA_Mode_Normal; //ѭģʽ  DMA_Mode_Circular
	DMA_InitStructure.DMA_Priority = DMA_Priority_VeryHigh ;//DMA ͨ x ӵиȼ 
	DMA_InitStructure.DMA_M2M = DMA_M2M_Disable;//DMA ͨ x ûΪڴ浽ڴ洫 

	DMA_Init(DMA1_Channel3, &DMA_InitStructure); 
//	DMA_ITConfig(DMA1_Channel3,DMA_IT_TC|DMA_IT_HT|DMA_IT_TE,DISABLE );  //رж
	DMA_ITConfig(DMA1_Channel3,DMA_IT_TC,ENABLE);	//ж
//	DMA_ITConfig(DMA1_Channel3,DMA_IT_HT,ENABLE);	//ж
	DMA_Cmd(DMA1_Channel3,ENABLE);
  DMA_ClearFlag(DMA1_FLAG_TC3);
}
//--------------------------------------------------------
//usart1 
//
void Usart1_DMA_Init(void)
{
		usart1_gpio_init();
		usart1_init();
		usart1_nvic_init();
	
		usart1_se_dma_init(Tx1Buffer,USART1_Send_Num);
		usart1_re_dma_init(Rx1Buffer,USART1_Rec_Num);

		dma_usart1_se_flag=0;
		dma_usart1_re_flag=0;
		usart1_re_dma_timeout=0;
}

u8 Usart1_Sart_Send(u8 Length)//ʼDMA
{
		if(dma_usart1_se_flag==0)
		{		
				USART1_Send_Num=Length;
				usart1_se_dma_init(Tx1Buffer,USART1_Send_Num);
				DMA_Cmd(DMA1_Channel4,ENABLE);
				dma_usart1_se_flag=1;
		}
		else
		{
				return 0;//fail
		}
		
		return 1;//suss
}

u8 Usart1_Send_sata(void)
{
	return dma_usart1_se_flag;//0 done 1 not done
}

u8 Usart1_Receive(void)
{
			usart1_re_dma_sum=DMA_GetCurrDataCounter(DMA1_Channel5);//ؽյʣֽ
			if(usart1_re_dma_sum==0|usart1_re_dma_sum==USART1_Rec_Num)  //dma   
			{	
				usart1_re_dma_timeout=0;
			}
			else
			{
				usart1_re_dma_timeout++;
				if(usart1_re_dma_timeout>=Receive_Timeout)	//ʱλDMA
				{
					usart1_re_dma_timeout=0;
					usart1_re_dma_init(Rx1Buffer,USART1_Rec_Num);
					return 2;// Timeout
				}
			}	
			
			if(dma_usart1_re_flag==1)
			{
				dma_usart1_re_flag=0;
				usart1_re_dma_init(Rx1Buffer,USART1_Rec_Num);		
				return 1;// done
			}
			return 0;//not done
}

void Usart1_DMA_Reset(void)
{
		usart1_re_dma_timeout=0;
		usart1_re_dma_init(Rx1Buffer,USART1_Rec_Num);
}

void Usart2_DMA_Reset(void)
{
		usart2_re_dma_timeout=0;
		usart2_re_dma_init(Rx2Buffer,USART2_Rec_Num);
}

void Usart3_DMA_Reset(void)
{
		usart3_re_dma_timeout=0;
		usart3_re_dma_init(Rx3Buffer,USART3_Rec_Num);
}
//--------------------------------------------------------
//usart2
//--------------------------------------------------------
void Usart2_DMA_Init(void)
{
		usart2_gpio_init();
		usart2_init();
		usart2_nvic_init();
	
		usart2_se_dma_init(Tx2Buffer,USART2_Send_Num);
		usart2_re_dma_init(Rx2Buffer,USART2_Rec_Num);

		dma_usart2_se_flag=0;
		dma_usart2_re_flag=0;
	
}

u8 Usart2_Sart_Send(void)//ʼDMA
{
		if(dma_usart2_se_flag==0)
		{
				usart2_se_dma_init(Tx2Buffer,USART2_Send_Num);
				DMA_Cmd(DMA1_Channel7,ENABLE);
				dma_usart2_se_flag=1;
		}
		else
		{
				return 0;//fail
		}
		
		return 1;//suss
}

u8 Usart2_Send_sata(void)
{
	return dma_usart2_se_flag;//0 done 1 not done
}

u8 Usart2_Receive(void)
{
			usart2_re_dma_sum=DMA_GetCurrDataCounter(DMA1_Channel6);//ؽյʣֽ
			if(usart2_re_dma_sum==0|usart2_re_dma_sum==USART2_Rec_Num)  //dma   
			{	
				usart2_re_dma_timeout=0;
			}
			else
			{
				usart2_re_dma_timeout++;
				if(usart2_re_dma_timeout>=Receive_Timeout)	//ʱλDMA
				{
					usart2_re_dma_timeout=0;
					usart2_re_dma_init(Rx2Buffer,USART2_Rec_Num);
				}
			}	
			
			if(dma_usart2_re_flag==1)
			{
				dma_usart2_re_flag=0;
				usart2_re_dma_init(Rx2Buffer,USART2_Rec_Num);		
				return 1;// done
			}
			return 0;//not done
}
//--------------------------------------------------------
//usart3 
//--------------------------------------------------------
void Usart3_DMA_Init(void)
{
		usart3_gpio_init();
		usart3_init();
		usart3_nvic_init();
	
		usart3_se_dma_init(Tx3Buffer,USART3_Send_Num);
		usart3_re_dma_init(Rx3Buffer,USART3_Rec_Num);

		dma_usart3_se_flag=0;
		dma_usart3_re_flag=0;
	
}

u8 Usart3_Sart_Send(void)//ʼDMA
{
		if(dma_usart3_se_flag==0)
		{
				usart3_se_dma_init(Tx3Buffer,USART3_Send_Num);
				DMA_Cmd(DMA1_Channel2,ENABLE);
				dma_usart3_se_flag=1;
		}
		else
		{
				return 0;//fail
		}
		
		return 1;//suss
}

u8 Usart3_Send_sata(void)
{
	return dma_usart3_se_flag;//0 done 1 not done
}

u8 Usart3_Receive(void)//USART3_Send_Num USART3_Rec_Num
{
			usart3_re_dma_sum=DMA_GetCurrDataCounter(DMA1_Channel3);//ؽյʣֽ
			if(usart3_re_dma_sum==0|usart3_re_dma_sum==USART3_Rec_Num)  //dma   
			{	
				usart3_re_dma_timeout=0;
			}
			else
			{
				usart3_re_dma_timeout++;
				if(usart3_re_dma_timeout>=Receive_Timeout)	//ʱλDMA
				{
					usart3_re_dma_timeout=0;
					usart3_re_dma_init(Rx3Buffer,USART3_Rec_Num);
				}
			}	
			
			if(dma_usart3_re_flag==1)
			{
				dma_usart3_re_flag=0;
				usart3_re_dma_init(Rx3Buffer,USART3_Rec_Num);		
				return 1;// done
			}
			return 0;//not done
}
//--------------------------------------------------------
			
//--------------------------------------------------------
void DMA1_Channel4_IRQHandler(void)	  //usart1 tx dma done
{	
	 DMA_ClearITPendingBit(DMA1_FLAG_TC4); //ж
	 DMA_ClearFlag(DMA1_FLAG_TC4);//ͨ 4 ɱ־λ
	 dma_usart1_se_flag=0;
}
void DMA1_Channel5_IRQHandler(void)	//usart1 rx dma done
{	
	 DMA_ClearITPendingBit(DMA1_FLAG_TC5); 
	 DMA_ClearFlag(DMA1_FLAG_TC5);
	 dma_usart1_re_flag=1;
}

void DMA1_Channel6_IRQHandler(void)	 //usart2 res
{	
	 DMA_ClearITPendingBit(DMA1_FLAG_TC6); 
	 DMA_ClearFlag(DMA1_FLAG_TC6);
	
	 dma_usart2_re_flag=1;
}
void DMA1_Channel7_IRQHandler(void)	//usart2 send
{	
	 DMA_ClearITPendingBit(DMA1_FLAG_TC7); 
	 DMA_ClearFlag(DMA1_FLAG_TC7);
	 dma_usart2_se_flag=0;
}

void DMA1_Channel3_IRQHandler(void)	 //usart3 res
{	
	 DMA_ClearITPendingBit(DMA1_FLAG_TC3); 
	 DMA_ClearFlag(DMA1_FLAG_TC3);
	
	 dma_usart3_re_flag=1;
}
void DMA1_Channel2_IRQHandler(void)	//usart3 send
{	
	 DMA_ClearITPendingBit(DMA1_FLAG_TC2); 
	 DMA_ClearFlag(DMA1_FLAG_TC2);
	 dma_usart3_se_flag=0;
}


